compile if not defined(SMALL)  -- If SMALL not defined, then being separately compiled
 define INCLUDING_FILE = 'HTMLTAGS.E'
const
   tryinclude 'MYCNF.E'        -- the user's configuration customizations.
                               -- Can include something like one of:
;  MY_HTML_ADDRESS = 'Larry Margolis<br>margoli@ibm.net'
;  MY_HTML_ADDRESS = '<a href="ME.html">Your Name Here</a><br><a href="mailto:yourid@yournode.site.org">yourid@yournode.site.org</a>'
                               -- This will be added at the end of each document created.
                               -- It will be after a <hr> and inside an <address>.

; Possible enhancement - a SAVE_EXIT that will update a "Last updated" line if present

 compile if not defined(SITE_CONFIG)
    const SITE_CONFIG = 'SITECNF.E'
 compile endif
 compile if SITE_CONFIG
    tryinclude SITE_CONFIG
 compile endif

const
 compile if not defined(WANT_DYNAMIC_PROMPTS)
   WANT_DYNAMIC_PROMPTS = 1
 compile endif
 compile if not defined(NLS_LANGUAGE)
   NLS_LANGUAGE = 'ENGLISH'
 compile endif
include NLS_LANGUAGE'.e'
include 'stdconst.e'
 compile if EVERSION >= 6
   EA_comment "CUSTEPM's HTML tags menu & support code."
 compile endif

 const
   MUST_BE_LINKED__MSG = 'For proper operation, this .ex file must be linked, not executed.'

defmain
   universal HTML_tags_menu_flag
   universal defaultmenu, activemenu
   call winmessagebox('HTMLTAGS', MUST_BE_LINKED__MSG, MB_CANCEL + MB_CUAWARNING + MB_MOVEABLE)
   if HTML_tags_menu_flag then
      deletemenu defaultmenu, 41, 0, 0
      call maybe_show_menu()
      HTML_tags_menu_flag = 0
   endif
compile endif

const
compile if not defined(WEB_BROWSER)
   WEB_BROWSER = 'explore.exe'
compile endif
compile if not defined(WEB_BROWSER_OPTIONS)
   WEB_BROWSER_OPTIONS = '-q'
compile endif
compile if not defined(HTML_EXTENSIONS)
   HTML_EXTENSIONS = 'HTM HTML SHTML'
compile endif

const  -- Text defined separately, for easier NLS translation
   HTMLTAGS_BAR__MSG =      TILDE_CHAR'HTML '
     PARAGRAPH_MENU__MSG = '~Paragraph'
     BREAK_MENU__MSG =     '~Break'
     LIST_ITEM_MENU__MSG = 'List ~item'
     DTDD_MENU__MSG =      '~DT / DD'
     LISTS_MENU__MSG =     '~List'
       ULIST_MENU__MSG =   '~Unordered list'
       OLIST_MENU__MSG =   '~Ordered list'
       DLIST_MENU__MSG =   '~Definition list'
       MLIST_MENU__MSG =   '~Menu list'
       RLIST_MENU__MSG =   'D~irectory list'
     HEADS_MENU__MSG =     '~Heading levels'
       HEAD1_MENU__MSG =   'Heading ~1'
       HEAD2_MENU__MSG =   'Heading ~2'
       HEAD3_MENU__MSG =   'Heading ~3'
       HEAD4_MENU__MSG =   'Heading ~4'
       HEAD5_MENU__MSG =   'Heading ~5'
       HEAD6_MENU__MSG =   'Heading ~6'
     EMPH_MENU__MSG =      '~Emphasis'
       EMPH_L_MENU__MSG =    '~Logical'
         EMPH_L_EM_MENU__MSG =     '~Emphasized'
         EMPH_L_STRONG_MENU__MSG = '~Strong'
         EMPH_L_CODE_MENU__MSG =   '~Code'
         EMPH_L_SAMP_MENU__MSG=    'S~ample'
         EMPH_L_KBD_MENU__MSG=     '~Keyboard'
         EMPH_L_VAR_MENU__MSG=     '~Variable'
         EMPH_L_DFN_MENU__MSG=     '~Definition'
         EMPH_L_CITE_MENU__MSG=    'C~itation'
       EMPH_P_MENU__MSG =  '~Physical'
         EMPH_P_T_MENU__MSG =  '~Typewriter'
         EMPH_P_B_MENU__MSG =  '~Bold'
         EMPH_P_I_MENU__MSG =  '~Italic'
         EMPH_P_U_MENU__MSG =  '~Underline'
       EMPH_B_MENU__MSG =  '~Block quote'
       EMPH_X_MENU__MSG =  'Pre-formatted ~text'
     SYMBOLS_MENU__MSG =   '~Symbols'
       SYMBL_A_MENU__MSG =   '~&'
       SYMBL_G_MENU__MSG =   '~>'
       SYMBL_L_MENU__MSG =   '~<'
       SYMBL_Q_MENU__MSG =   '~"'
       SYMBL_N_MENU__MSG =   'Non-break ~space'
       SYMBL_COP_MENU__MSG =   'Copyright'
       SYMBL_REG_MENU__MSG =   'Registered'
     HR_MENU__MSG =        'Horizontal ~rule'
     ADDRESS_MENU__MSG =        '~Address'
     ANCHOR_MENU__MSG =        'A~nchor'
     ANCHOR_CRE_MENU__MSG =    '~Create here'
     ANCHOR_REF_HERE_MENU__MSG='~Internal link'
     ANCHOR_REF_EXT_MENU__MSG= '~External link'
     IMAGE_MENU__MSG =     'Ima~ge'
     DOC_MENU__MSG =       'Docu~ments'
       HTMLDOC_MENU__MSG =      '~HTML'
     BROWSE_MENU__MSG =    '~View in browser'

compile if WANT_DYNAMIC_PROMPTS
   HTMLTAGS_BARP__MSG =     \1'Create HTML tags'
     PARAGRAPH_MENUP__MSG = \1'Insert paragraph tag after current line'
     BREAK_MENUP__MSG =     \1'Insert break tag at end of current line'
     LIST_ITEM_MENUP__MSG = \1'Insert list item tag after current line'
     DTDD_MENUP__MSG =      \1'Insert <dt> and <dd> tags after current line'
     LISTS_MENUP__MSG =     \1'Create a list'
       ULIST_MENUP__MSG =     \1'Create unordered (bulleted) list'
       OLIST_MENUP__MSG =     \1'Create ordered (numbered) list'
       DLIST_MENUP__MSG =     \1'Create definition (glossary) list'
       MLIST_MENUP__MSG =     \1'Create menu list (typically one line per item)'
       RLIST_MENUP__MSG =     \1'Create directory list (short elements, typically < 20 chars each)'
     HEADS_MENUP__MSG =     \1'Apply heading levels to block or char. mark, or current word'
       HEAD_MENUP__MSG =      \1'Apply indicated heading level to block or char. mark, or current word'
     EMPH_MENUP__MSG =      \1'Add emphasis to a phrase - block or char. mark, or current word'
       EMPH_L_MENUP__MSG =  \1'Add logical emphasis (recommended)'
         EMPH_L_EM_MENUP__MSG =     \1'Emphasize text (typically, italic)'
         EMPH_L_STRONG_MENUP__MSG = \1'Strongly emphasize text (typically, bold)'
         EMPH_L_CODE_MENUP__MSG =   \1'For an example of code (typically, monospaced)'
         EMPH_L_SAMP_MENUP__MSG=    \1'For a sequence of literal characters'
         EMPH_L_KBD_MENUP__MSG=     \1'For text typed by user'
         EMPH_L_VAR_MENUP__MSG=     \1'For a variable name'
         EMPH_L_DFN_MENUP__MSG=     \1'For the defining instance of a term'
         EMPH_L_CITE_MENUP__MSG=    \1'For a citation'
       EMPH_P_MENUP__MSG =  \1'Add physical emphasis (should be avoided)'
         EMPH_P_x_MENUP__MSG =  \1'Apply indicated emphasis to block or char. mark, or current word'
       EMPH_B_MENUP__MSG =  \1'Tag marked lines as a block quote'
       EMPH_X_MENUP__MSG =  \1'Tag marked lines as pre-formatted text.'
     SYMBOLS_MENUP__MSG =   \1'Enter a symbol for a reserved character'
       SYMBL_x_MENUP__MSG =   \1'Key in the symbol for the indicated character'
       SYMBL_ACCENTED_MENUP__MSG = \1'Symbols for the indicated character with accents'
     ADDRESS_MENUP__MSG =   \1'Label as an address the block or char. mark, or current word'
     ANCHOR_MENUP__MSG =    \1'Create an anchor'
     ANCHOR_CRE_MENUP__MSG =    \1'Label as an anchor the block or char. mark, or current word'
     ANCHOR_REF_HERE_MENUP__MSG=\1'Create a link to an anchor in this document'
     ANCHOR_REF_EXT_MENUP__MSG= \1'Create a link to an anchor located elsewhere'
     HR_MENUP__MSG =        \1'Create a horizontal rule'
     IMAGE_MENUP__MSG =     \1'Create an Image tag'
     DOC_MENUP__MSG =       \1'Create a document'
     HTMLDOC_MENUP__MSG =       \1'Create an HTML document'
     BROWSE_MENUP__MSG =    \1'Invoke web browser against current document'
compile else
   HTMLTAGS_BARP__MSG =     ''
     PARAGRAPH_MENUP__MSG = ''
     BREAK_MENUP__MSG =     ''
     LIST_ITEM_MENUP__MSG = ''
     DTDD_MENUP__MSG =      ''
     LISTS_MENUP__MSG =     ''
     OLIST_MENUP__MSG =     ''
     ULIST_MENUP__MSG =     ''
     DLIST_MENUP__MSG =     ''
     MLIST_MENUP__MSG =     ''
     RLIST_MENUP__MSG =     ''
     HEADS_MENUP__MSG =     ''
       HEAD_MENUP__MSG =    ''
     EMPH_MENUP__MSG =      ''
       EMPH_L_MENUP__MSG =  ''
         EMPH_L_EM_MENUP__MSG =     ''
         EMPH_L_STRONG_MENUP__MSG = ''
         EMPH_L_CODE_MENUP__MSG =   ''
         EMPH_L_SAMP_MENUP__MSG=    ''
         EMPH_L_KBD_MENUP__MSG=     ''
         EMPH_L_VAR_MENUP__MSG=     ''
         EMPH_L_DFN_MENUP__MSG=     ''
         EMPH_L_CITE_MENUP__MSG=    ''
       EMPH_P_MENUP__MSG =  ''
         EMPH_P_x_MENUP__MSG =  ''
       EMPH_B_MENUP__MSG =  ''
       EMPH_X_MENUP__MSG =  ''
     SYMBOLS_MENUP__MSG =   ''
       SYMBL_x_MENUP__MSG = ''
       SYMBL_ACCENTED_MENUP__MSG = ''
     ADDRESS_MENUP__MSG =   ''
     ANCHOR_MENUP__MSG =    ''
     ANCHOR_CRE_MENUP__MSG =   ''
     ANCHOR_REF_HERE_MENUP__MSG=''
     ANCHOR_REF_EXT_MENUP__MSG= ''
     HR_MENUP__MSG =        ''
     IMAGE_MENUP__MSG =     ''
     DOC_MENUP__MSG =        ''
     HTMLDOC_MENUP__MSG =   ''
     BROWSE_MENUP__MSG =    ''
compile endif  -- WANT_DYNAMIC_PROMPTS

   ANCHOR_TITLE__MSG =    'Anchor - Create here'
   ANCHOR_PROMPT__MSG =   'Enter the name for this anchor'
   EXTLINK_TITLE__MSG =   'Anchor - External link'
   EXTLINK_PROMPT__MSG =  'Enter the URL for this anchor'
   DRAGDROP_TITLE__MSG =  'Dropped file'
   DRAGDROP_PROMPT__MSG = 'Enter optional alternate text'
   NO_ANCHORS__MSG =      'No anchors defined in this file.'
   INTLINK_TITLE__MSG =   'Anchor - Internal link'
   INTLINK_PROMPT__MSG =  'Select the anchor to which you wish link'
   URL_LIST_PROMPT__MSG = 'Select the URL to which you wish link'
;  MODIFIED_PROMPT__MSG = 'Document has been modified.  Save changes?'
   IMAGE_TITLE__MSG =     'Image'
   IMAGE_PROMPT__MSG =    'Enter the URL for this image'

   OK__MSG =          '~OK'
   CANCEL__MSG =      'Cancel'  -- This is also in ENGLISH.E
   TOP__MSG =         '~Top'
   MID__MSG =         '~Middle'
   BOT__MSG =         '~Bottom'
   LIST__MSG =        '~List...'
   EDITLIST__MSG =    '~Edit list...'

   SELECT__MSG =          '~Select'
   NONE__MSG =            '~None'

definit
;   'postme build_htmltags_menu'

;defc build_htmltags_menu
   universal defaultmenu, activemenu
   universal activeaccel
   universal HTML_tags_menu_flag
   deletemenu defaultmenu, 6, 0, 0  -- delete the existing Help menu (we want it to stay at the right)

   buildsubmenu defaultmenu, 41, HTMLTAGS_BAR__MSG, HTMLTAGS_BARP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4100, PARAGRAPH_MENU__MSG,     'HTML_IL <p>'PARAGRAPH_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4101, BREAK_MENU__MSG,         'HTML_suf <br>'BREAK_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4102, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   41, 4103, LIST_ITEM_MENU__MSG,     'HTML_IL <li>'LIST_ITEM_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4104, DTDD_MENU__MSG,          'HTML_IML |<dt>|<dd>'DTDD_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4105, LISTS_MENU__MSG,         LISTS_MENUP__MSG, 17, 0
     buildmenuitem defaultmenu,   41, 4106, ULIST_MENU__MSG,         'HTML_IML |<ul>|<li>|<li>|</ul>'ULIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4107, OLIST_MENU__MSG,         'HTML_IML |<ol>|<li>|<li>|</ol>'OLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4108, DLIST_MENU__MSG,         'HTML_IML |<dl>|<dt>|<dd>||<dt>|<dd>|</dl>'DLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4109, MLIST_MENU__MSG,         'HTML_IML |<menu>|<li>|<li>|</menu>'MLIST_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4110, RLIST_MENU__MSG,         'HTML_IML |<dir>|<li>|<li>|</dir>'RLIST_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4111, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   41, 4112, HEADS_MENU__MSG,         HEADS_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4113, HEAD1_MENU__MSG,         'HTML_EM h1'HEAD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4114, HEAD2_MENU__MSG,         'HTML_EM h2'HEAD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4115, HEAD3_MENU__MSG,         'HTML_EM h3'HEAD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4116, HEAD4_MENU__MSG,         'HTML_EM h4'HEAD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4117, HEAD5_MENU__MSG,         'HTML_EM h5'HEAD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4118, HEAD6_MENU__MSG,         'HTML_EM h6'HEAD_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4119, EMPH_MENU__MSG,          EMPH_MENUP__MSG, 17, 0
     buildmenuitem defaultmenu,   41, 4120, EMPH_L_MENU__MSG,          EMPH_L_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4121, EMPH_L_EM_MENU__MSG,       'HTML_EM em'EMPH_L_EM_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4122, EMPH_L_STRONG_MENU__MSG,   'HTML_EM strong'EMPH_L_STRONG_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4123, EMPH_L_CODE_MENU__MSG,     'HTML_EM code'EMPH_L_CODE_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4124, EMPH_L_SAMP_MENU__MSG,     'HTML_EM samp'EMPH_L_SAMP_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4125, EMPH_L_KBD_MENU__MSG,      'HTML_EM kbd'EMPH_L_KBD_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4126, EMPH_L_VAR_MENU__MSG,      'HTML_EM var'EMPH_L_VAR_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4127, EMPH_L_DFN_MENU__MSG,      'HTML_EM dfn'EMPH_L_DFN_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4128, EMPH_L_CITE_MENU__MSG,     'HTML_EM cite'EMPH_L_CITE_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4129, EMPH_P_MENU__MSG,          EMPH_P_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4130, EMPH_P_T_MENU__MSG,        'HTML_EM tt'EMPH_P_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4131, EMPH_P_B_MENU__MSG,        'HTML_EM b'EMPH_P_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4132, EMPH_P_I_MENU__MSG,        'HTML_EM i'EMPH_P_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4133, EMPH_P_U_MENU__MSG,        'HTML_EM u'EMPH_P_x_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4134, EMPH_X_MENU__MSG,          'HTML_EML pre'EMPH_X_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4135, EMPH_B_MENU__MSG,          'HTML_EML blockquote'EMPH_B_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4136, SYMBOLS_MENU__MSG,       SYMBOLS_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4137, SYMBL_A_MENU__MSG,         'HTML_keyin &amp;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4138, SYMBL_G_MENU__MSG,         'HTML_keyin &gt;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4139, SYMBL_L_MENU__MSG,         'HTML_keyin &lt;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4140, SYMBL_Q_MENU__MSG,         'HTML_keyin &quot;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4141, SYMBL_N_MENU__MSG,         'HTML_keyin &nbsp;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4142, SYMBL_COP_MENU__MSG,       'HTML_keyin &copy;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4143, SYMBL_REG_MENU__MSG,       'HTML_keyin &reg;'SYMBL_x_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4144, \0,                      '',      4, 0
       buildmenuitem defaultmenu, 41, 4145, '',                       'HTML_keyin &laquo'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4146, '',                       'HTML_keyin &raquo'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4147, '',                       'HTML_keyin &iquest'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4148, '',                       'HTML_keyin &iexcl'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4149, '~A, a',                   SYMBL_ACCENTED_MENUP__MSG, 17 + 2048, 0
       buildmenuitem defaultmenu, 41, 4150, ' (A + `)',               'HTML_keyin &Agrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4151, " (A + ')",               'HTML_keyin &Aacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4152, ' (A + ^)',               'HTML_keyin &Acirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4153, ' (A + ~~)',              'HTML_keyin &Atilde;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4154, ' (A + )',               'HTML_keyin &Auml;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4155, ' (A + )',               'HTML_keyin &Aring;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4156, ' (A + E)',               'HTML_keyin &AElig;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4157, ' (a + `)',               'HTML_keyin &agrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4158, " (a + ')",               'HTML_keyin &aacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4159, ' (a + ^)',               'HTML_keyin &acirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4160, ' (a + ~~)',              'HTML_keyin &atilde;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4161, ' (a + )',               'HTML_keyin &auml;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4162, ' (a + )',               'HTML_keyin &aring;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4163, ' (a + e)',               'HTML_keyin &aelig;'SYMBL_x_MENUP__MSG, 32769, 0
       buildmenuitem defaultmenu, 41, 4164, '',                       'HTML_keyin &Ccedil;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4165, '',                       'HTML_keyin &ccedil;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4166, '~E, e',                   SYMBL_ACCENTED_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4167, ' (E + `)',               'HTML_keyin &Egrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4168, " (E + ')",               'HTML_keyin &Eacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4169, ' (E + ^)',               'HTML_keyin &Ecirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4170, ' (E + )',               'HTML_keyin &Euml;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4171, ' (e + `)',               'HTML_keyin &egrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4172, " (e + ')",               'HTML_keyin &eacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4173, ' (e + ^)',               'HTML_keyin &ecirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4174, ' (e + )',               'HTML_keyin &euml;'SYMBL_x_MENUP__MSG, 32769, 0
       buildmenuitem defaultmenu, 41, 4175, '~I, i',                   SYMBL_ACCENTED_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4176, ' (I + `)',               'HTML_keyin &Igrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4177, " (I + ')",               'HTML_keyin &Iacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4178, ' (I + ^)',               'HTML_keyin &Icirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4179, ' (I + )',               'HTML_keyin &Iuml;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4180, ' (i + `)',               'HTML_keyin &igrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4181, " (i + ')",               'HTML_keyin &iacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4182, ' (i + ^)',               'HTML_keyin &icirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4183, ' (i + )',               'HTML_keyin &iuml;'SYMBL_x_MENUP__MSG, 32769, 0
       buildmenuitem defaultmenu, 41, 4184, '',                       'HTML_keyin &Ntilde;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4185, '',                       'HTML_keyin &ntilde;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4186, '~O, o',                   SYMBL_ACCENTED_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4187, ' (O + `)',               'HTML_keyin &Ograve;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4188, " (O + ')",               'HTML_keyin &Oacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4189, ' (O + ^)',               'HTML_keyin &Ocirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4190, ' (O + ~~)',               'HTML_keyin &Otilde;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4191, ' (O + )',               'HTML_keyin &Ouml;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4192, ' (o + `)',               'HTML_keyin &ograve;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4193, " (o + ')",               'HTML_keyin &oacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4194, ' (o + ^)',               'HTML_keyin &ocirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4195, ' (o + ~~)',               'HTML_keyin &otilde;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4196, ' (o + )',               'HTML_keyin &ouml;'SYMBL_x_MENUP__MSG, 32769, 0
       buildmenuitem defaultmenu, 41, 4197, '~U, u',                   SYMBL_ACCENTED_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4198, ' (U + `)',               'HTML_keyin &Ugrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4199, " (U + ')",               'HTML_keyin &Uacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4200, ' (U + ^)',               'HTML_keyin &Ucirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4201, ' (U + )',               'HTML_keyin &Uuml;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4202, ' (u + `)',               'HTML_keyin &ugrave;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4203, " (u + ')",               'HTML_keyin &uacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4204, ' (u + ^)',               'HTML_keyin &ucirc;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4205, ' (u + )',               'HTML_keyin &uuml;'SYMBL_x_MENUP__MSG, 32769, 0
       buildmenuitem defaultmenu, 41, 4206, '~Y, y',                   SYMBL_ACCENTED_MENUP__MSG, 17, 0
       buildmenuitem defaultmenu, 41, 4207, " (Y + ')",               'HTML_keyin &Yacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4208, " (y + ')",               'HTML_keyin &yacute;'SYMBL_x_MENUP__MSG, 0, 0
       buildmenuitem defaultmenu, 41, 4209, ' (y + )',               'HTML_keyin &yuml;'SYMBL_x_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4210, \0,                      '',      33025, 0
     buildmenuitem defaultmenu,   41, 4211, HR_MENU__MSG,              'HTML_IL <hr>'HR_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4212, ADDRESS_MENU__MSG,         'HTML_EM address'ADDRESS_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4213, ANCHOR_MENU__MSG,          ANCHOR_MENUP__MSG, 17, 0
     buildmenuitem defaultmenu,   41, 4214, ANCHOR_CRE_MENU__MSG,      'HTML_ANCHOR'ANCHOR_CRE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4215, ANCHOR_REF_HERE_MENU__MSG, 'HTML_LCL_LINK'ANCHOR_REF_HERE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4216, ANCHOR_REF_EXT_MENU__MSG,  'HTML_EXT_LINK'ANCHOR_REF_EXT_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4217, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   41, 4218, IMAGE_MENU__MSG,           'HTML_IMAGE'IMAGE_MENUP__MSG, 0, 0
     buildmenuitem defaultmenu,   41, 4219, DOC_MENU__MSG,             DOC_MENUP__MSG, 17, 0
     buildmenuitem defaultmenu,   41, 4220, HTMLDOC_MENU__MSG,         'HTML_DOC'DOC_MENUP__MSG, 32769, 0
     buildmenuitem defaultmenu,   41, 4221, \0,                      '',      4, 0
     buildmenuitem defaultmenu,   41, 4222, BROWSE_MENU__MSG,          'HTML_BROWSE'BROWSE_MENUP__MSG, 0, 0

   call readd_help_menu()
   HTML_tags_menu_flag = 1

   buildacceltable activeaccel, 'dokey a+H', AF_CHAR+AF_ALT,    72, 4298  -- a+H
   buildacceltable activeaccel, 'dokey a+H', AF_CHAR+AF_ALT,   104, 4299  -- a+h
   activateacceltable  activeaccel

defc HTML_IL = -- InsertLine
   insertline arg(1), .line+1
   '+1'
   end_line

defc HTML_pref = -- Prefix line with arg
   replaceline arg(1) || textline(.line), .line
   .col = length(arg(1))+1

defc HTML_suf = -- Suffix line with arg
   replaceline textline(.line)arg(1), .line
   call einsert_line()

defc HTML_IML = -- Insert Many Lines
   parse value strip(arg(1),'L') with delim 2 rest
   nextline = .line+1
   do while rest <> ''
      parse value rest with line (delim) rest
      insertline line, nextline
      nextline = nextline + 1
   enddo
   '+2'
   end_line

defc HTML_em
   level = arg(1)
   call HTML_insert_tags('<'level'>', '</'level'>')

defc HTML_eml
   mt = marktype()
   if leftstr(mt, 1)<>'L' then
      sayerror -283  -- "Line mark required"
      return
   endif
   getmark firstline, lastline, firstcol, lastcol, fileid
   insertline '</'arg(1)'>', lastline+1, fileid
   insertline '<'arg(1)'>', firstline, fileid
   call pset_mark(firstline+1, lastline+1, firstcol, lastcol, mt, fileid)

defproc HTML_insert_tags(start_tag, end_tag)
   mt = marktype()
   if pos(leftstr(mt,1), 'BC') then  -- Block or Character mark
      getfileid fid
      getmark firstline,lastline,firstcol,lastcol,fileid
      if fid<>fileid then
         sayerror 'Wrong file - check mark'
         return
      endif
   else
      firstline = .line; lastline = .line;
      call pend_word(); lastcol = .col
      call pbegin_word(); firstcol = .col
   endif
   if arg(3) <> '' & not pos(' ', arg(3)) then  -- Set an optional bookmark
      'bm' arg(3) 4 firstline firstcol
   endif
   .col=lastcol+1
   lastline
   i_s = insert_state()
   if not i_s then insert_toggle; endif
   keyin end_tag
   firstline
   .col=firstcol
   keyin start_tag
   if pos(leftstr(mt,1), 'BC') then  -- Block or Character mark
      l = length(start_tag)
      call pset_mark(firstline, lastline, firstcol+l, lastcol+(l*(lastline=firstline)), mt, fileid)
   endif
   if not i_s then insert_toggle; endif

defc HTML_DOC
   oldmod = .modify
   if .last=1 & textline(1)='' then
      deleteline 1
   endif
   start_line = .line
;  start_size = .last
   'HTML_IML |<!DOCTYPE HTML PUBLIC "-//W3 Organization//DTD W3 HTML 2.0//EN">|<html>|<head>|<title>|</title>|</head>|<body>|<h1>||</h1>|<p>||</body>|</html>'
compile if defined(MY_HTML_ADDRESS)
   getsearch save_search
   'xcom l |</body>'
   insertline '<hr>'
   insertline '<address>'
   setsearch save_search
   my_upper_address = upcase(MY_HTML_ADDRESS)
   p0 = 1
   do forever
      p1 = pos('<BR>', my_upper_address, p0)
      if not p1 then
         insertline substr(MY_HTML_ADDRESS, p0)
         leave
      endif
      insertline substr(MY_HTML_ADDRESS, p0, p1+4-p0)
      p0 = p1+4
   enddo
   insertline '</address>'
compile endif -- defined(MY_HTML_ADDRESS)
   start_line+4; end_line
   .modify = oldmod

defc HTML_keyin
   i_s = insert_state()
   if not i_s then insert_toggle; endif
   keyin arg(1)
   if not i_s then insert_toggle; endif

defc HTML_ANCHOR
   parse value entrybox(ANCHOR_TITLE__MSG,'/'OK__MSG'/'Cancel__MSG'/',\0,'',200,
          atoi(1) || atoi(0) || gethwndc(APP_HANDLE) ||
          ANCHOR_PROMPT__MSG) with button 2 name \0
   if button<>\1 then return; endif
   if name='' then return; endif
   call HTML_insert_tags('<a name="'name'">', '</a>', name)

defc HTML_LCL_LINK
   universal EPM_utility_array_ID
   do_array 3, EPM_utility_array_ID, 'bmi.0', bmcount          -- Index says how many bookmarks there are
   if bmcount = 0 then sayerror NO_ANCHORS__MSG; return; endif
   getfileid startfid
   'xcom e /c bookmark'
   if rc<>-282 then  -- -282 = sayerror("New file")
      sayerror ERROR__MSG rc BAD_TMP_FILE__MSG sayerrortext(rc)
      return
   endif
   browse_mode = browse()     -- query current state
   if browse_mode then call browse(0); endif
   .autosave = 0
   getfileid bmfid
   display -2
   do i=1 to bmcount
      do_array 3, EPM_utility_array_ID, 'bmi.'i, markname   -- Get name number i
      if markname='' then iterate; endif  -- has been deleted
       -- Find that bookmark name
      if get_array_value(EPM_utility_array_ID, 'bmn.'markname, bmindex) then  -- Unexpected; ignore it & continue
         iterate
      endif
      parse value bmindex with bmindex fid .
      if fid<>startfid then
         iterate
      endif
      insertline markname, bmfid.last+1, bmfid
   enddo
   activatefile bmfid
   if .last>2 then
      call sort(2, .last, 1, 40, bmfid, 'I')
   endif
   if browse_mode then call browse(1); endif  -- restore browse state
   display 2
   if not .modify then  -- Nothing added?
      sayerror NO_ANCHORS__MSG
      'xcom quit'
      return
   endif
   buflen = filesize() + .last + 1
   bufhndl = buffer(CREATEBUF, 'LISTBOX', buflen, 1 )  -- create a private buffe
   if not bufhndl then sayerror 'CREATEBUF' ERROR_NUMBER__MSG RC; return; endif
   noflines = buffer(PUTBUF, bufhndl, 1, 0, APPENDCR)
   .modify = 0
   'xcom quit'
;  display 1
   if not noflines then sayerror 'PUTBUF' ERROR_NUMBER__MSG RC; return; endif
   usedsize = buffer(USEDSIZEBUF,bufhndl)
   parse value listbox(INTLINK_TITLE__MSG,
 compile if EPM32
                       \0 || atol(usedsize) || atoi(32) || atoi(bufhndl),
 compile else
                       \0 || atoi(usedsize) || atoi(bufhndl) || atoi(32),
 compile endif -- EPM32
                       '/'OK__MSG'/'Cancel__MSG,1,5,min(noflines,12),0,
 compile if EVERSION >= 5.60
                       gethwndc(APP_HANDLE) || atoi(1) || atoi(1) || atoi(0) || INTLINK_PROMPT__MSG) with button 2 anchor \0
 compile else
                       atoi(1) || atoi(1) || atoi(0) || gethwndc(APP_HANDLE) || INTLINK_PROMPT__MSG) with button 2 anchor \0
 compile endif
   call buffer(FREEBUF, bufhndl)
   if button<>\1 then return; endif
   call HTML_insert_tags('<a href="#'anchor'">', '</a>')

defc HTML_EXT_LINK
   res = HTML_geturl(EXTLINK_TITLE__MSG, EXTLINK_PROMPT__MSG, url)
   if res > 1 | url='' then return; endif
   call HTML_insert_tags('<a href="'url'">', '</a>')
   if not res then
      call HTML_logurl(url)
   endif

defproc HTML_logurl(url)
   logfile = url_list_filename()\0
   url = url\13\10\0
   call windowmessage(1,  getpminfo(EPMINFO_EDITCLIENT),
 compile if EVERSION >= 5.60
                      5496,        -- EPM_EDIT_LOGAPPEND
 compile else
                      5453,        -- EPM_EDIT_LOGAPPEND
 compile endif
                      ltoa(offset(logfile) || selector(logfile), 10),
                      ltoa(offset(url) || selector(url), 10) )

; This routine puts up an entry box to request a URL.  If a logfile exists,
; the entrybox will have a "List" button, which if selected will bring up a
; listbox containing previously-entered URLs.
; Return codes:
;    0 - All OK, URL entered; log it.
;    1 - All OK, URL selected from list; do not log it.
;    2 - All OK, user asked to edit log file; do not continue
;    3 - User cancelled a dialog
;    4 - An unexpected error occurred
defproc HTML_geturl(title_msg, prompt_msg, var url)
   logfile = url_list_filename()
   if exist(logfile) then
      buttons = '/'OK__MSG'/'LIST__MSG'/'Cancel__MSG'/'
      list_button = \2
   else
      buttons = '/'OK__MSG'/'Cancel__MSG'/'
      list_button = \9  -- Never gonna happen
   endif
   parse value entrybox(title_msg, buttons, \0, '', 200,
          atoi(1) || atoi(0) || gethwndc(APP_HANDLE) ||
          prompt_msg) with button 2 url \0
   if button=list_button then
      getfileid startfid
      'xcom e /d' logfile
      if rc then
         sayerror ERROR__MSG rc '"'logfile'" -' sayerrortext(rc)
         return 4
      endif
      browse_mode = browse()     -- query current state
      if browse_mode then call browse(0); endif
      if .last>2 then
         getfileid urlfid
         call sort(2, .last, 1, 40, urlfid, 'I')
      endif
      replaceline \13 || textline(1), 1
      if browse_mode then call browse(1); endif  -- restore browse state
      call listbox_buffer_from_file(startfid, bufhndl, noflines, usedsize)
      parse value listbox(title_msg,
    compile if EPM32
                          \0 || atol(usedsize) || atoi(32) || atoi(bufhndl),
    compile else
                          \0 || atoi(usedsize) || atoi(bufhndl) || atoi(32),
    compile endif -- EPM32
                          '/'OK__MSG'/'EDITLIST__MSG'/'Cancel__MSG,1,5,min(noflines,12),0,
    compile if EVERSION >= 5.60
                          gethwndc(APP_HANDLE) || atoi(1) || atoi(1) || atoi(0) || URL_LIST_PROMPT__MSG) with button 2 url \0
    compile else
                          atoi(1) || atoi(1) || atoi(0) || gethwndc(APP_HANDLE) || URL_LIST_PROMPT__MSG) with button 2 url \0
    compile endif
      call buffer(FREEBUF, bufhndl)
      if button=\2 then
         'e' logfile
         return 2
      elseif button<>\1 then
         return 3
      endif
      return 1
   elseif button<>\1 then
      return 3
   endif
   return 0

; Add HTM, HTML to create an anchor. (Lisa)
defc DRAGDROP_HTM, DRAGDROP_HTML
   if wordpos(filetype(), HTML_EXTENSIONS) then
      'MH_gotoposition'
      'HTML_keyin <a href="'html_path(arg(1))'"> </a>'
   else
      'e "'arg(1)'"'
   endif

defc DRGDRPTYP_WEBEXPLORER_URL
   if wordpos(filetype(), HTML_EXTENSIONS) then
      'MH_gotoposition'
      'e "'arg(1)'"'
      if rc then return; endif
      url = textline(1)
      'quit'
      if pos('<', url) then
         parse value url with '<' url '>'
      endif
      url = word(url, 1)
      if pos('://', url) then
         'HTML_keyin <a href="'html_path(url)'"> </a>'
      else
         sayerror "Doesn't appear to be a URL:  <"url'>'
      endif
   else
      'e "'arg(1)'"'
   endif

defc DRAGDROP_GIF, DRAGDROP_BMP, DRAGDROP_IMG, DRAGDROP_JPG, DRAGDROP_JPE, DRAGDROP_JPEG =
   'MH_gotoposition'
   parse value entrybox(DRAGDROP_TITLE__MSG,'/'TOP__MSG'/'MID__MSG'/'BOT__MSG'/'Cancel__MSG'/',\0,'',200,
          atoi(1) || atoi(0) || gethwndc(APP_HANDLE) ||
          DRAGDROP_PROMPT__MSG) with button 2 alt \0
   if button<>\1 & button<>\2 & button<>\3  then return; endif
   if alt<>'' then
      alt = ' alt="'alt'"'
   endif
   'HTML_keyin <img src="'html_path(arg(1))'" align='word('TOP MIDDLE BOTTOM', asc(button))alt'>'
; Possible enhancement:  Read first 10 bytes of image; if first 3 = 'GIF' then
; W =  atoi(substr(image,7,2)); H  =  atoi(substr(image,9,2));
; add to <img   "height="H "width="W

defc HTML_IMAGE
   res = HTML_geturl(IMAGE_TITLE__MSG, IMAGE_PROMPT__MSG, url)
   if res > 1 | url='' then return; endif
   parse value entrybox(IMAGE_TITLE__MSG,'/'TOP__MSG'/'MID__MSG'/'BOT__MSG'/'Cancel__MSG'/',\0,'',200,
          atoi(1) || atoi(0) || gethwndc(APP_HANDLE) ||
          DRAGDROP_PROMPT__MSG) with button 2 alt \0
   if button<>\1 & button<>\2 & button<>\3  then return; endif
   if alt<>'' then
      alt = ' alt="'alt'"'
   endif
   'HTML_keyin <img src="'html_path(url)'" align='word('TOP MIDDLE BOTTOM', asc(button))alt'>'
   if not res then
      call HTML_logurl(url)
   endif

defproc html_path(pathname)
   ls = lastpos('\', .filename)
   if ls then
      thispath = upcase(leftstr(.filename, ls))
      if upcase(leftstr(pathname, ls)) = thispath then  -- We can use a relative path.
         pathname = substr(pathname, ls+1)
      endif
   endif
   return translate(pathname, '/', '\')

defproc url_list_filename()
   universal appname, url_file
   if url_file = '' then
      inifile = queryprofile(0, appname, 'EPMIniPath')
      url_file = leftstr(inifile, lastpos('\', inifile)) || 'url.lst'
      if leftstr(url_file,1)='\' then  -- relative to boot drive
compile if EVERSION >= 6
         drivenum = 1234
         call dynalink32('DOSCALLS',          -- dynamic link library name
                         '#348',              -- ordinal for DOS32QuerySysInfo
                         atol(5)          ||  -- Start index (QSV_BOOT_DRIVE)
                         atol(5)          ||  -- End index (QSV_BOOT_DRIVE)
                         address(drivenum)||  -- buffer
                         atol(4),2)           -- Buffer length
         url_file = chr(96+ltoa(drivenum, 10))':'url_file
compile else
         globalseg = 12
         localseg = 12

         call dynalink('DOSCALLS',             -- dynamic link library name
                       '#8',                   -- ordinal value for DosGetInfoSeg
                       selector(globalseg) ||  -- string selector
                       offset(globalseg)   ||  -- string offset
                       selector(localseg)  ||  -- string selector
                       offset(localseg) )      -- string offset

         globalseg=itoa(globalseg,10)
         url_file = chr(96+itoa(peek(globalseg,36,2), 10))':'url_file
compile endif
      endif
   endif
   return url_file

defc HTML_BROWSE =
   if .modify then
      result = winmessagebox(translate(BROWSE_MENU__MSG, ' ', '~'), MODIFIED_PROMPT__MSG, MB_YESNOCANCEL + MB_ICONQUESTION + MB_MOVEABLE)
      if result=MBID_YES then
         'save'
      elseif result=MBID_NO then
         -- nop
      else
         return
      endif
   endif
   'start' WEB_BROWSER WEB_BROWSER_OPTIONS 'file:///'.filename
